#include<iostream>
#include<algorithm>
#include<string>
#include<vector>
#define MAXN 3000
#define MAXM 100000
#define MAXA 100000
#define MAXK 900
#define DIGITS 18
#define BASE ((long long int)1e18)
using namespace std;
int a[MAXN],pref[MAXA+1];
typedef vector <long long int> bignum;
inline bool operator< (const bignum& a, const bignum& b) {
    if (a.size()<b.size()) return true;
    if (b.size()<a.size()) return false;
    for (int i=a.size()-1; i>=0; i--) {
        if (a[i]<b[i]) return true;
        if (a[i]>b[i]) return false;
    }
    return false;
}
inline bignum operator+ (const bignum& a, const bignum& b) {
    bignum res=a;
    int len=b.size();
    long long int carry=0;
    for (int i=0; i<=len; i++) {
        if ((i==len)&&(carry==0)) break;
        if (res.size()<=i) res.push_back(0);
        res[i]+=carry+(i<len?b[i]:0);
        carry=res[i]/BASE;
        res[i]%=BASE;
    }
    if (carry!=0) res.push_back(carry);
    return res;
}

vector <pair <bignum, int> > queries[MAXN+1];
int ans[MAXM];
bignum pascal[2][MAXN/2+1];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,m;
    cin >> n >> m ;
    for (int i=0; i<n; i++) {
        cin >> a[i] ;
        pref[a[i]]++;
    }
    for (int i=1; i<=MAXA; i++) {
        pref[i]+=pref[i-1];
    }
    for (int i=0; i<m; i++) {
        int l,r;
        cin >> l >> r ;
        string k;
        cin >> k ;
        bignum num;
        num.reserve(k.size()/DIGITS+1);
        for (int j=k.size()-1; j>=0; j-=DIGITS) {
            long long int val=0;
            for (int h=max(j-DIGITS+1,0); h<=j; h++) {
                val*=10;
                val+=(k[h]-'0');
            }
            num.push_back(val);
        }
        queries[pref[r]-pref[l-1]].push_back({num, i});
    }

    for (auto [ignore, ind] : queries[0]) {
        ans[ind]=-1;
    }
    pascal[0][0]={1};
    for (int i=1; i<=n; i++) {
        bool curr=i&1,prv=curr^1;
        pascal[curr][0]={1};
        for (int j=1; j<=i/2; j++) {
            if ((pascal[prv][j-1].size()==0)||(pascal[prv][j].size()==0)) break;
            pascal[curr][j]=pascal[prv][j-1]+pascal[prv][j];
            if (pascal[curr][j].size()>MAXK) {
                pascal[curr][j]={};
                break;
            }
        }
        if (i%2==1) pascal[curr][i/2+1]=pascal[curr][i/2];

        sort(queries[i].begin(),queries[i].end(),[] (const pair <bignum, int>& l, const pair <bignum, int>& r) {
             if (l.first<r.first) return true;
             return false;
        });
        int ind=1;
        for (auto [k, i] : queries[i]) {
            for (;;) {
                if (pascal[curr][ind].size()==0) break;
                if (!(pascal[curr][ind]<k)) break;
                ind++;
            }
            if (pascal[curr][ind].size()==0) ans[i]=-1;
            else ans[i]=ind;
        }
    }

    for (int i=0; i<m; i++) {
        cout << ans[i] << "\n";
    }
    cout << endl ;
    return 0;
}
